Option TargetCPU zx328L
Option Objects


Class DisplayGUI Includes AxeDisplay

	Private Const DownloadCounterAddress as Integer = 100
	Private Const maxIntro as Byte = 10
	Dim downloadStatus as Byte
	
	
	Public Sub _Create()
		If FirstTime Then
			Call PersistentPoke(maxIntro,DownloadCounterAddress)
		Else
			downloadStatus = PersistentPeek(DownloadCounterAddress)
			If downloadStatus > 0 then
				downloadStatus = downloadStatus - 1
				Call PersistentPoke(downloadStatus,DownloadCounterAddress)
			End If
		End If
	End Sub


	Private Function ShownEnoughTimes() as Boolean
		downloadStatus = PersistentPeek(DownloadCounterAddress)
		If downloadStatus > 0 Then 
			ShownEnoughTimes = False
		Else
			ShownEnoughTimes = True
		End If
	End Function
	

	Public Function Greeting() as String
		Dim MahyongText as String
		MahyongText = "Welkom, groeten:"
		Call myGUI.DisplayLine(MahyongText, 1)
		MahyongText = "Joost & Jurjen!"
		Call myGUI.DisplayLine(MahyongText, 2)
		DelayMilliseconds(3000)
		If Not ShownEnoughTimes Then
			MahyongText = "Mahyong Calc v2"
			Call myGUI.DisplayLine(MahyongText, 1)
			MahyongText = "Tafelschikking:"
			Call myGUI.DisplayLine(MahyongText, 2)
			DelayMilliseconds(3000)
			Call ClearDisplay
			MahyongText = "Speler1 "
			Call myGUI.DisplayString(MahyongText, 1)
			DelayMilliseconds(500)
			MahyongText = "Speler2 "
			Call myGUI.DisplayString(MahyongText, 2)
			DelayMilliseconds(500)
			MahyongText = "Speler3 "
			Call myGUI.DisplayString(MahyongText, 3)
			DelayMilliseconds(500)
			MahyongText = "Speler4 "
			Call myGUI.DisplayString(MahyongText, 4)
			DelayMilliseconds(3000)
			MahyongText = "Speler1 heeft de"
			Call myGUI.DisplayLine(MahyongText, 1)
			MahyongText = "calculator ..."
			Call myGUI.DisplayLine(MahyongText, 2)
			DelayMilliseconds(3000)
			MahyongText = "Bij keuze:"
			Call myGUI.DisplayLine(MahyongText, 1)
			MahyongText = "*=Ja #=Nee"
			Call myGUI.DisplayLine(MahyongText, 2)
			DelayMilliseconds(3000)
			MahyongText = "Invoeren punten:"
			Call myGUI.DisplayLine(MahyongText, 1)
			MahyongText = "puntenaantal + *"
			Call myGUI.DisplayLine(MahyongText, 2)
			DelayMilliseconds(3000)
			MahyongText = "Fout gegaan bij"
			Call myGUI.DisplayLine(MahyongText, 1)
			MahyongText = "invoeren punten?"
			Call myGUI.DisplayLine(MahyongText, 2)
			DelayMilliseconds(3000)
			MahyongText = "#:getal opnieuw"
			Call myGUI.DisplayLine(MahyongText, 1)
			MahyongText = "##:ronde opnieuw"
			Call myGUI.DisplayLine(MahyongText, 2)
			DelayMilliseconds(3000)		
			MahyongText = "Rode lat wordt"
			Call myGUI.DisplayLine(MahyongText, 1)
			MahyongText = "bijgehouden ..."
			Call myGUI.DisplayLine(MahyongText, 2)
			DelayMilliseconds(3000)	
			MahyongText = "Herhalen?"
			Call myGUI.DisplayLine(MahyongText, 1)
			MahyongText = "*=Ja #=Nee"
			Call myGUI.DisplayLine(MahyongText, 2)
			Greeting = WaitForKeyPress
		Else
			MahyongText = "Mahyong Calc v2"
			Call myGUI.DisplayLine(MahyongText, 1)
			MahyongText = "Veel Succes!"
			Call myGUI.DisplayLine(MahyongText, 2)
			DelayMilliseconds(3000)
			Greeting = "#"
		End If
	End Function
	
	
	Public Sub Display4Numbers (ByRef userPoints() as Long)
		Dim numString as String
		Dim userNr as Byte
		Call ClearDisplay
		For userNr = 1 To 4
			DelayMilliseconds(750)
			numstring = CStr(userpoints(userNr))
			If userPoints(userNr) >= 0 Then numstring = " " & numstring
			Call DisplayString(numString,userNr)
		Next userNr
	End Sub


	Public Sub Enter4Numbers(ByRef userPoints() as Long)
	
		Dim karakter as String 
		Dim emptyString as String = "        "
		Dim emptyString5 as String = "     "
		Dim dotChar as String = ".       "
	
		Dim numStr as String
		Dim userNr as Byte = 1
		Dim MahyongUser as Byte
		Dim errorKeyPressed as Boolean = False
		Dim firstKey as Boolean = True

		For userNr = 1 To 4 
			numStr = "(" & CStr(userNr) & ")" & emptyString5
			DelayMilliseconds(300)
			Call DisplayString(numStr, UserNr)
		Next userNr		
		userNr = 1
		numStr = ""
		Call ClearQueue(keyQueue)
		Call SetCursor(1)
		Call ControlCursor(True,True)
		Do While userNr <= 4
			Do While (StatusQueue(keyQueue))
				Dim key as Byte
				Call GetQueue(keyQueue, key, 1)	
				Call ControlCursor(False,False)
				If firstKey Then 
					Call DisplayString(emptyString, userNr)
					Call SetCursor(userNr)
					firstKey = False
				End If
				If Chr(key) <> "#" AND Chr(key) <> "*" Then
					karakter = Chr(key)
					numStr = numStr & karakter
					Call EchoCharacter(karakter)
					errorKeyPressed = False
				ElseIf Chr(key) = "*" Then
					Dim strVal as Long
					Dim succes as Boolean
					Call ValueL(numStr, strVal, succes)
					userPoints(userNr) = strVal
					numstr = ""
					userNr = userNr + 1
					firstKey = True
					If userNr <= 4 Then
						Call SetCursor(userNr)
						Call ControlCursor(True,True)
					End If
					errorKeyPressed = False
				Else
					If errorKeyPressed = False Then
						Dim errortext as String = "FOUTJE! "
						numstr = ""
						Call DisplayString(errortext, usernr)
						DelayMilliseconds(1000)
						firstKey = True
						Call DisplayString(emptyString, userNr)
						Call SetCursor(userNr)
						Call ControlCursor(True,True)
						errorKeyPressed = True
					Else
						Dim messageString as String
						Call ControlCursor(False,False)
						Call ClearDisplay
						messageString = "Voer alle punten"
						Call DisplayLine(messageString, 1)
						messageString = "opnieuw in:"
						Call DisplayLine(messageString, 2)
						DelayMilliseconds(1500)
						errorKeyPressed = False
						For userNr = 1 To 4 
							numStr = "(" & CStr(userNr) & ")" & emptyString5
							Call DisplayString(numStr, UserNr)
						Next userNr
						userNr = 1			
						numstr = ""						
						firstKey = True
						Call SetCursor(userNr)
						Call ControlCursor(True,True)
					End If
				End If
			Loop
		Loop
		DelayMilliseconds(1000)
	End Sub


	Public Function RequestUserNr(ByRef MahyongText as String, ByVal confirmText as String = "(OK/nee)" ) as Byte
	
		Dim emptyString as String = ""
		Dim keyNumericalValue as Byte = 0
	
		Call ClearQueue(keyQueue)
		Call ClearLine(2)
		Call DisplayLine(MahyongText, 1)
		Call DisplayLine(emptyString, 2)
		Call ControlCursor(True,True)
		Dim userEntered as Boolean = False
		Dim confirmed as Boolean = False
		Dim key as Byte = 48
		Do While Not confirmed
			If StatusQueue(keyQueue) Then
				Call GetQueue(keyQueue, key, 1)
				If Not userEntered Then
					If key < 53 And key > 48 Then
						Dim s as String = Chr(key)
						Call DisplayLine(s, 2)
						keyNumericalValue = key - 48
						userEntered = True
						Dim confirmString As String = ConfirmText
						Call DisplayString(confirmString,2)
						Call SetCursor(1)
					End If
				Else
					If Chr(key) = "*" Then
						confirmed = True
					Else 
						If Chr(key) = "#" Then 
							userEntered = False
							Call ClearLine(2)
							Call SetCursor(1)
						End If
					End If
				End If
			End If
		Loop
		Call ControlCursor(False,False)
		RequestUserNr = keyNumericalValue
		DelayMilliseconds(1000)
		Call ResetDisplay
	End Function


	Public Function WaitForKeyPress() As String
	
		Dim confirmed as Boolean = False
		Dim key as Byte
	
		ClearQueue(keyQueue)
		Do While Not StatusQueue(keyQueue) 
			DelayMilliseconds(200)
		Loop
		Call GetQueue(keyQueue, key, 1)
		WaitForKeyPress = Chr(key)
	End Function
	
End Class



Dim myGame as MahyongEvent = _Create
Dim myGUI as DisplayGUI = _Create
Dim mahYongWinner as Byte
Dim playerNr as Byte
Dim userPoints (1 to 4) as Long
Dim MahyongText as String 
Dim dummyStr as String

Sub Main()

	Call myGUI.ControlCursor(False,False)

	'Activate necessary tasks and related resources
	Call OpenQueue(keyQueue, SizeOf(keyQueue))
	CallTask keyPadTask, KeyPadTaskStack

	'Show Greeting + intro text
	Do 
		MahyongText = myGUI.Greeting
	Loop Until MahyongText <>"*"
	
	Do 
		'Display round status
		If myGame.GetRonde = 1 Then 
			MahyongText = "Ronde: " & CStr(myGame.GetRonde)
		Else 
			MahyongText = "Ronde: " & CStr(myGame.GetRonde) & " Rood: " & Cstr(myGame.GetRodeLatPos)
		End If
		Call myGUI.DisplayLine(MahyongText, 1)
		MahyongText = "Rondewind: " & CStr(myGame.GetRondeWind)
		Call myGUI.DisplayLine(MahyongText, 2)
		DelayMilliseconds(3000)		
		
		If myGame.GetRonde = 1 Then
			'Ask for who has rode lat
			MahyongText = "Wie is rood?"
			playerNr = myGUI.RequestUserNr(MahyongText)
			'Set the proper Mahyong user
			Call myGame.InitRodeLatUser(playerNr)
		End If
		
		'Ask for four new points for the current round
		MahyongText = "Voer de punten"
		Call myGUI.DisplayLine(MahyongText, 1)
		MahyongText = "van de ronde in:"
		Call myGUI.DisplayLine(MahyongText, 2)
		DelayMilliseconds(1500)
		Call myGUI.ResetDisplay
		Call myGUI.Enter4Numbers(userPoints)
		'copy new user points to mahyong objects (newPoints)
		Call myGame.ImportNewPoints(userPoints)
		
		'Ask for winner's user number
		MahyongText = "Wie was MahYong?"
		playerNr = myGUI.RequestUserNr(MahyongText)
		'Set the proper Mahyong user
		'Call myGame.PlayerObject(playerNr).setMahyong(True)
		Call myGame.SetMahyongUser(playerNr)
		
		'Now calculate the result (one Mahyong game played) and store in "points"
		Call myGame.Calculate
		'get the new totals (points)
		Call myGame.GetNewTotals(userPoints)
		
		'Show the new results
		MahyongText = "Hier volgt de"
		Call myGUI.DisplayLine(MahyongText, 1)
		MahyongText = "nieuwe stand:"
		Call myGUI.DisplayLine(MahyongText, 2)
		DelayMilliseconds(1000)
		Call myGUI.Display4Numbers(userPoints)
		
		dummyStr = myGUI.WaitForKeyPress
		
	Loop
	
End Sub